class DashBoardDetailBean {
  bool status;
  int statusCode;
  String message;
  Data data;

  DashBoardDetailBean({this.status, this.statusCode, this.message, this.data});

  DashBoardDetailBean.fromJson(Map<String, dynamic> json) {
    status = json['status'];
    statusCode = json['status_code'];
    message = json['message'];
    data = json['data'] != null ? new Data.fromJson(json['data']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['status'] = this.status;
    data['status_code'] = this.statusCode;
    data['message'] = this.message;
    if (this.data != null) {
      data['data'] = this.data.toJson();
    }
    return data;
  }
}

class Data {
  List<Dashboard> dashboard;
  List<Chart> chart;

  Data({this.dashboard, this.chart});

  Data.fromJson(Map<String, dynamic> json) {
    if (json['dashboard'] != null) {
      dashboard = new List<Dashboard>();
      json['dashboard'].forEach((v) {
        dashboard.add(new Dashboard.fromJson(v));
      });
    }
    if (json['chart'] != null) {
      chart = new List<Chart>();
      json['chart'].forEach((v) {
        chart.add(new Chart.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.dashboard != null) {
      data['dashboard'] = this.dashboard.map((v) => v.toJson()).toList();
    }
    if (this.chart != null) {
      data['chart'] = this.chart.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class Dashboard {
  String name;
  int currentMonth;
  int lastMonth;

  Dashboard({this.name, this.currentMonth, this.lastMonth});

  Dashboard.fromJson(Map<String, dynamic> json) {
    name = json['name'];
    currentMonth = json['current_month'];
    lastMonth = json['last_month'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['name'] = this.name;
    data['current_month'] = this.currentMonth;
    data['last_month'] = this.lastMonth;
    return data;
  }
}

class Chart {
  int dealWonCount;
  int dealCreateCount;
  String month;

  Chart({this.dealWonCount, this.dealCreateCount, this.month});

  Chart.fromJson(Map<String, dynamic> json) {
    dealWonCount = json['deal_won_count'];
    dealCreateCount = json['deal_create_count'];
    month = json['month'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['deal_won_count'] = this.dealWonCount;
    data['deal_create_count'] = this.dealCreateCount;
    data['month'] = this.month;
    return data;
  }
}
