/// status : true
/// status_code : 200
/// message : "Data Fetched Successfully"
/// data : [{"id":1,"accountid":2,"leadid":1,"contactid":2,"dealid":null,"desc":"Discussed with management might take time for the product rollout","owner_id":1,"created_at":"2021-02-11T01:46:49.000000Z","updated_at":"2021-02-11T01:46:49.000000Z"}]

class NotesDetailsBean {
  bool status;
  int statusCode;
  String message;
  List<NotesListDetailsBean> data;

  NotesDetailsBean({this.status, this.statusCode, this.message, this.data});

  NotesDetailsBean.fromJson(Map<String, dynamic> json) {
    status = json['status'];
    statusCode = json['status_code'];
    message = json['message'];
    if (json['data'] != null) {
      data = new List<NotesListDetailsBean>();
      json['data'].forEach((v) {
        data.add(new NotesListDetailsBean.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['status'] = this.status;
    data['status_code'] = this.statusCode;
    data['message'] = this.message;
    if (this.data != null) {
      data['data'] = this.data.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class NotesListDetailsBean {
  int id;
  int accountid;
  int leadid;
  int contactid;
  dynamic dealid;
  String desc;
  int ownerId;
  String createdAt;
  String updatedAt;

  NotesListDetailsBean(
      {this.id,
      this.accountid,
      this.leadid,
      this.contactid,
      this.dealid,
      this.desc,
      this.ownerId,
      this.createdAt,
      this.updatedAt});

  NotesListDetailsBean.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    accountid = json['accountid'];
    leadid = json['leadid'];
    contactid = json['contactid'];
    dealid = json['dealid'];
    desc = json['desc'];
    ownerId = json['owner_id'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['accountid'] = this.accountid;
    data['leadid'] = this.leadid;
    data['contactid'] = this.contactid;
    data['dealid'] = this.dealid;
    data['desc'] = this.desc;
    data['owner_id'] = this.ownerId;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}
