class TaskDetailBean {
  bool status;
  int statusCode;
  String message;
  List<TaskDetailList> data;

  TaskDetailBean({this.status, this.statusCode, this.message, this.data});

  TaskDetailBean.fromJson(Map<String, dynamic> json) {
    status = json['status'];
    statusCode = json['status_code'];
    message = json['message'];
    if (json['data'] != null) {
      data = new List<TaskDetailList>();
      json['data'].forEach((v) {
        data.add(new TaskDetailList.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['status'] = this.status;
    data['status_code'] = this.statusCode;
    data['message'] = this.message;
    if (this.data != null) {
      data['data'] = this.data.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class TaskDetailList {
  int id;
  Accountid accountid;
  Leadid leadid;
  Contactid contactid;
  Dealid dealid;
  Activitytypeid activitytypeid;
  Activitytypeid statusid;
  String desc;
  String duedate;
  String createdAt;
  String updatedAt;
  OwnerId ownerId;

  TaskDetailList(
      {this.id,
      this.accountid,
      this.leadid,
      this.contactid,
      this.dealid,
      this.activitytypeid,
      this.statusid,
      this.desc,
      this.duedate,
      this.createdAt,
      this.updatedAt,
      this.ownerId});

  TaskDetailList.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    accountid = json['accountid'] != null
        ? new Accountid.fromJson(json['accountid'])
        : null;
    leadid =
        json['leadid'] != null ? new Leadid.fromJson(json['leadid']) : null;
    contactid = json['contactid'] != null
        ? new Contactid.fromJson(json['contactid'])
        : null;
    dealid =
        json['dealid'] != null ? new Dealid.fromJson(json['dealid']) : null;
    activitytypeid = json['activitytypeid'] != null
        ? new Activitytypeid.fromJson(json['activitytypeid'])
        : null;
    statusid = json['statusid'] != null
        ? new Activitytypeid.fromJson(json['statusid'])
        : null;
    desc = json['desc'];
    duedate = json['duedate'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
    ownerId = json['owner_id'] != null
        ? new OwnerId.fromJson(json['owner_id'])
        : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    if (this.accountid != null) {
      data['accountid'] = this.accountid.toJson();
    }
    if (this.leadid != null) {
      data['leadid'] = this.leadid.toJson();
    }
    if (this.contactid != null) {
      data['contactid'] = this.contactid.toJson();
    }
    if (this.dealid != null) {
      data['dealid'] = this.dealid.toJson();
    }
    if (this.activitytypeid != null) {
      data['activitytypeid'] = this.activitytypeid.toJson();
    }
    if (this.statusid != null) {
      data['statusid'] = this.statusid.toJson();
    }
    data['desc'] = this.desc;
    data['duedate'] = this.duedate;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    if (this.ownerId != null) {
      data['owner_id'] = this.ownerId.toJson();
    }
    return data;
  }
}

class Accountid {
  int id;
  String companyname;
  String email;
  dynamic phone;
  dynamic website;
  int industry;
  int annualrevenue;
  int noofemployees;
  String area;
  String address1;
  String address2;
  String state;
  int pincode;
  String country;
  int ownerId;
  int statusid;
  String createdAt;
  String updatedAt;

  Accountid(
      {this.id,
      this.companyname,
      this.email,
      this.phone,
      this.website,
      this.industry,
      this.annualrevenue,
      this.noofemployees,
      this.area,
      this.address1,
      this.address2,
      this.state,
      this.pincode,
      this.country,
      this.ownerId,
      this.statusid,
      this.createdAt,
      this.updatedAt});

  Accountid.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    companyname = json['companyname'];
    email = json['email'];
    phone = json['phone'];
    website = json['website'];
    industry = json['industry'];
    annualrevenue = json['annualrevenue'];
    noofemployees = json['noofemployees'];
    area = json['area'];
    address1 = json['address1'];
    address2 = json['address2'];
    state = json['state'];
    pincode = json['pincode'];
    country = json['country'];
    ownerId = json['owner_id'];
    statusid = json['statusid'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['companyname'] = this.companyname;
    data['email'] = this.email;
    data['phone'] = this.phone;
    data['website'] = this.website;
    data['industry'] = this.industry;
    data['annualrevenue'] = this.annualrevenue;
    data['noofemployees'] = this.noofemployees;
    data['area'] = this.area;
    data['address1'] = this.address1;
    data['address2'] = this.address2;
    data['state'] = this.state;
    data['pincode'] = this.pincode;
    data['country'] = this.country;
    data['owner_id'] = this.ownerId;
    data['statusid'] = this.statusid;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class Leadid {
  int id;
  String title;
  String firstname;
  String lastname;
  String email;
  dynamic phone;
  int leadSourceId;
  String companyname;
  String website;
  int industry;
  int annualrevenue;
  int noofemployees;
  String description;
  int salesarea;
  String address1;
  dynamic address2;
  String state;
  int pincode;
  String country;
  String tags;
  int ownerId;
  int statusid;
  int accountid;
  int createdby;
  int updatedby;
  String createdAt;
  String updatedAt;

  Leadid(
      {this.id,
      this.title,
      this.firstname,
      this.lastname,
      this.email,
      this.phone,
      this.leadSourceId,
      this.companyname,
      this.website,
      this.industry,
      this.annualrevenue,
      this.noofemployees,
      this.description,
      this.salesarea,
      this.address1,
      this.address2,
      this.state,
      this.pincode,
      this.country,
      this.tags,
      this.ownerId,
      this.statusid,
      this.accountid,
      this.createdby,
      this.updatedby,
      this.createdAt,
      this.updatedAt});

  Leadid.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    title = json['title'];
    firstname = json['firstname'];
    lastname = json['lastname'];
    email = json['email'];
    phone = json['phone'];
    leadSourceId = json['leadSourceId'];
    companyname = json['companyname'];
    website = json['website'];
    industry = json['industry'];
    annualrevenue = json['annualrevenue'];
    noofemployees = json['noofemployees'];
    description = json['description'];
    salesarea = json['salesarea'];
    address1 = json['address1'];
    address2 = json['address2'];
    state = json['state'];
    pincode = json['pincode'];
    country = json['country'];
    tags = json['tags'];
    ownerId = json['owner_id'];
    statusid = json['statusid'];
    accountid = json['accountid'];
    createdby = json['createdby'];
    updatedby = json['updatedby'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['title'] = this.title;
    data['firstname'] = this.firstname;
    data['lastname'] = this.lastname;
    data['email'] = this.email;
    data['phone'] = this.phone;
    data['leadSourceId'] = this.leadSourceId;
    data['companyname'] = this.companyname;
    data['website'] = this.website;
    data['industry'] = this.industry;
    data['annualrevenue'] = this.annualrevenue;
    data['noofemployees'] = this.noofemployees;
    data['description'] = this.description;
    data['salesarea'] = this.salesarea;
    data['address1'] = this.address1;
    data['address2'] = this.address2;
    data['state'] = this.state;
    data['pincode'] = this.pincode;
    data['country'] = this.country;
    data['tags'] = this.tags;
    data['owner_id'] = this.ownerId;
    data['statusid'] = this.statusid;
    data['accountid'] = this.accountid;
    data['createdby'] = this.createdby;
    data['updatedby'] = this.updatedby;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class Contactid {
  int id;
  int accountid;
  String firstname;
  String secondName;
  String email;
  dynamic mobile;
  dynamic phone;
  String dept;
  String title;
  String area;
  String address1;
  String address2;
  String state;
  int statusid;
  String createdAt;
  String updatedAt;

  Contactid(
      {this.id,
      this.accountid,
      this.firstname,
      this.secondName,
      this.email,
      this.mobile,
      this.phone,
      this.dept,
      this.title,
      this.area,
      this.address1,
      this.address2,
      this.state,
      this.statusid,
      this.createdAt,
      this.updatedAt});

  Contactid.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    accountid = json['accountid'];
    firstname = json['firstname'];
    secondName = json['secondName'];
    email = json['email'];
    mobile = json['mobile'];
    phone = json['phone'];
    dept = json['dept'];
    title = json['title'];
    area = json['area'];
    address1 = json['address1'];
    address2 = json['address2'];
    state = json['state'];
    statusid = json['statusid'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['accountid'] = this.accountid;
    data['firstname'] = this.firstname;
    data['secondName'] = this.secondName;
    data['email'] = this.email;
    data['mobile'] = this.mobile;
    data['phone'] = this.phone;
    data['dept'] = this.dept;
    data['title'] = this.title;
    data['area'] = this.area;
    data['address1'] = this.address1;
    data['address2'] = this.address2;
    data['state'] = this.state;
    data['statusid'] = this.statusid;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class Dealid {
  int id;
  int companyid;
  int contactid;
  int statusid;
  String name;
  String desc;
  int probability;
  int dealcost;
  String closingdate;
  int ownerId;
  String createdAt;
  String updatedAt;

  Dealid(
      {this.id,
      this.companyid,
      this.contactid,
      this.statusid,
      this.name,
      this.desc,
      this.probability,
      this.dealcost,
      this.closingdate,
      this.ownerId,
      this.createdAt,
      this.updatedAt});

  Dealid.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    companyid = json['companyid'];
    contactid = json['contactid'];
    statusid = json['statusid'];
    name = json['name'];
    desc = json['desc'];
    probability = json['probability'];
    dealcost = json['dealcost'];
    closingdate = json['closingdate'];
    ownerId = json['owner_id'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['companyid'] = this.companyid;
    data['contactid'] = this.contactid;
    data['statusid'] = this.statusid;
    data['name'] = this.name;
    data['desc'] = this.desc;
    data['probability'] = this.probability;
    data['dealcost'] = this.dealcost;
    data['closingdate'] = this.closingdate;
    data['owner_id'] = this.ownerId;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class Activitytypeid {
  int id;
  String page;
  String key;
  String name;
  String status;
  String desc;
  String createdAt;
  String updatedAt;

  Activitytypeid(
      {this.id,
      this.page,
      this.key,
      this.name,
      this.status,
      this.desc,
      this.createdAt,
      this.updatedAt});

  Activitytypeid.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    page = json['page'];
    key = json['key'];
    name = json['name'];
    status = json['status'];
    desc = json['desc'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['page'] = this.page;
    data['key'] = this.key;
    data['name'] = this.name;
    data['status'] = this.status;
    data['desc'] = this.desc;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class OwnerId {
  int id;
  String uid;
  Null fcmids;
  String name;
  String email;
  int phone;
  Null photourl;
  int roleid;
  String status;
  String createdAt;
  String updatedAt;

  OwnerId(
      {this.id,
      this.uid,
      this.fcmids,
      this.name,
      this.email,
      this.phone,
      this.photourl,
      this.roleid,
      this.status,
      this.createdAt,
      this.updatedAt});

  OwnerId.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    uid = json['uid'];
    fcmids = json['fcmids'];
    name = json['name'];
    email = json['email'];
    phone = json['phone'];
    photourl = json['photourl'];
    roleid = json['roleid'];
    status = json['status'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['uid'] = this.uid;
    data['fcmids'] = this.fcmids;
    data['name'] = this.name;
    data['email'] = this.email;
    data['phone'] = this.phone;
    data['photourl'] = this.photourl;
    data['roleid'] = this.roleid;
    data['status'] = this.status;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}
