class UserViewBean {
  bool status;
  int statusCode;
  String message;
  List<UserListBean> data;

  UserViewBean({this.status, this.statusCode, this.message, this.data});

  UserViewBean.fromJson(dynamic json) {
    status = json["status"];
    statusCode = json["status_code"];
    message = json["message"];
    if (json["data"] != null) {
      data = [];
      json["data"].forEach((v) {
        data.add(UserListBean.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map["status"] = status;
    map["status_code"] = statusCode;
    map["message"] = message;
    if (data != null) {
      map["data"] = data.map((v) => v.toJson()).toList();
    }
    return map;
  }
}

class UserListBean {
  int id;
  String uid;
  dynamic fcmids;
  String name;
  String email;
  String phone;
  String photourl;
  int roleid;
  dynamic status;
  String createdAt;
  String updatedAt;

  UserListBean(
      {this.id,
      this.uid,
      this.fcmids,
      this.name,
      this.email,
      this.phone,
      this.photourl,
      this.roleid,
      this.status,
      this.createdAt,
      this.updatedAt});

  UserListBean.fromJson(dynamic json) {
    id = json["id"];
    uid = json["uid"];
    fcmids = json["fcmids"];
    name = json["name"];
    email = json["email"];
    phone = json["phone"];
    photourl = json["photourl"];
    roleid = json["roleid"];
    status = json["status"];
    createdAt = json["created_at"];
    updatedAt = json["updated_at"];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map["id"] = id;
    map["uid"] = uid;
    map["fcmids"] = fcmids;
    map["name"] = name;
    map["email"] = email;
    map["phone"] = phone;
    map["photourl"] = photourl;
    map["roleid"] = roleid;
    map["status"] = status;
    map["created_at"] = createdAt;
    map["updated_at"] = updatedAt;
    return map;
  }
}
