import 'package:bui_component/FilterComponent/FilterScreenComponent.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:example/Utils/Utility.dart';
import 'package:example/Utils/loader.dart';
import 'package:flutter/material.dart';
import 'package:shared_preferences/shared_preferences.dart';

class FilterScreen extends StatefulWidget {
  Color primaryColor;
  Color secondaryColor;

  String filterFormData;
  String fromPageId;
  Function(String jsonObj) isActionApply;

  FilterScreen({
    Key key,
    this.primaryColor,
    this.secondaryColor,
    this.filterFormData,
    this.isActionApply,
    this.fromPageId,
  }) : super(key: key);

  @override
  _FilterScreenState createState() => _FilterScreenState();
}

class _FilterScreenState extends State<FilterScreen> {
  String form;
  final GlobalKey<ScaffoldState> _scaffoldkey = new GlobalKey<ScaffoldState>();
  SharedPreferences prefs;

  bool isLoader = true;

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    initSharedPref();
  }

  Future<void> initSharedPref() async {
    prefs = await SharedPreferences.getInstance();
    String stringValue = prefs.getString(AppStrings.OWNER_ID);
    setState(() {
      isLoader = false;
    });
    form = widget.filterFormData;
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      key: _scaffoldkey,
      appBar: AppBar(
        backgroundColor: widget.primaryColor,
        title: Text("Filter Screen"),
      ),
      backgroundColor: widget.secondaryColor,
      body: Stack(
        children: [
          isLoader
              ? Center(
                  child: Loader(
                    loaderColor: widget.secondaryColor,
                  ),
                )
              : FilterViewComponent(
                  primaryColor: widget.primaryColor,
                  secondaryColor: widget.secondaryColor,
                  form: form,
                  actionSaveFunction: (String jsonObj, dynamic data) {
                    Utils.hideKeyboard(context);

                    applyFilterSettings(jsonObj, data);
                  },
                ),
        ],
      ),
    );
  }

  Future<void> applyFilterSettings(String jsonObj, data) async {
    /*if (jsonObj != null) {
                for (int i = 0; i < data['fields'].length; i++) {
                  if (data['fields'][i]['value'].toString() == "null" ||
                      data['fields'][i]['value'].toString() == "0") {
                    Utils.showInSnackBar(
                        scaffoldKey: _scaffoldkey,
                        message: "Required All Field",
                        snackBarType: SNACK_BAR_TYPE.FAILURE);
                  } else {

                    break;
                  }
                }
              } else {
                Utils.showInSnackBar(
                    scaffoldKey: _scaffoldkey,
                    message: "Value",
                    snackBarType: SNACK_BAR_TYPE.SUCCESS);
              }*/

    Utils.showInSnackBar(
        scaffoldKey: _scaffoldkey,
        message: "Apply Action Clicked",
        snackBarType: SNACK_BAR_TYPE.SUCCESS);

    if (widget.fromPageId != null) {
      widget.isActionApply(jsonObj.toString());
      Navigator.pop(context);
    }
  }
}
