import 'package:bui_component/ButtonsComponent/buttonComponent.dart';
import 'package:bui_component/Constants/AppColors.dart';
import 'package:bui_component/Constants/AppStrings.dart';
import 'package:bui_component/Constants/SvgPictures.dart';
import 'package:bui_component/Constants/fontFamily.dart';
import 'package:bui_component/Constants/fontSize.dart';
import 'package:flutter/material.dart';
import 'package:flutter_svg/svg.dart';

class CommonComponent extends StatefulWidget {
  String svgPictureImage;
  String updateText;
  String buttonText;
  String title;
  Color secondaryColor;
  Color primaryColor;
  Function() actionUpdate;
  Function() backPressed;
  Widget gifAnimated;
  bool isLeadingIconTrue;
  double padding;
  double height;
  double width;

  @override
  _CommonComponentState createState() => _CommonComponentState();

  CommonComponent({
    this.svgPictureImage,
    this.updateText,
    this.buttonText,
    this.secondaryColor,
    this.primaryColor,
    this.actionUpdate,
    this.backPressed,
    this.gifAnimated,
    this.width,
    this.height,
    this.padding,
    this.title,
    this.isLeadingIconTrue,
  });
}

class _CommonComponentState extends State<CommonComponent> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        backgroundColor: AppColors.primaryColor,
        automaticallyImplyLeading: false,
        title: Text(
          widget.title ?? AppStrings.UPDATE,
          style: TextStyle(color: Colors.white),
        ),
        leading: widget.isLeadingIconTrue == true
            ? InkWell(
                onTap: () {
                  widget.backPressed();
                },
                child: Icon(Icons.arrow_back_rounded))
            : null,
      ),
      body: Container(
        padding: EdgeInsets.all(widget.padding ?? 16),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          crossAxisAlignment: CrossAxisAlignment.center,
          children: <Widget>[
            Container(
              height: widget.height ?? 200,
              width: widget.width ?? MediaQuery.of(context).size.width * 0.9,
              //color: Colors.black45,
              padding: EdgeInsets.only(left: 16.0, right: 16.0, top: 16.0),
              child: widget.gifAnimated ??
                  SvgPicture.asset(
                    widget.svgPictureImage ?? SvgPictures.DOG,
                    placeholderBuilder: (context) =>
                        CircularProgressIndicator(),
                    height: 128.0,
                    allowDrawingOutsideViewBox: false,
                  ),
            ),
            SizedBox(
              height: 20.0,
            ),
            Text(
              widget.updateText ?? AppStrings.EMPTY_STRING,
              style: TextStyle(
                color: widget.primaryColor ?? AppColors.primaryColor,
                wordSpacing: 1,
                letterSpacing: 1,
                fontSize: FontSize.FONT_20,
                fontWeight: FontWeight.normal,
                fontFamily: FontFamily.Gilroy,
              ),
            ),
            SizedBox(
              height: 20.0,
            ),
            Button.mini(
              width: MediaQuery.of(context).size.width * 0.3,
              onPressed: () {
                widget.actionUpdate();
              },
              buttonSize: ButtonSize.medium,
              buttonType: ButtonType.custom,
              btnColor: widget.secondaryColor ?? AppColors.APP_COLOR_PRIMARY,
              btnTextColor: Colors.white,
              btnText: widget.buttonText ?? "Update",
              elevation: 10,
            ),
          ],
        ),
      ),
    );
  }
}
