/*
    Refer License for Terms & Conditions
 */

import 'dart:convert';

import 'package:bui_component/Constants/AppColors.dart';
import 'package:bui_component/JsonFormComponent/json_schema.dart';
import 'package:flutter/material.dart';

class FilterViewComponent extends StatefulWidget {
  FilterViewComponent({
    Key key,
    this.primaryColor,
    this.secondaryColor,
    @required this.form,
    this.actionSaveFunction,
  }) : super(key: key);

  Color primaryColor;
  Color secondaryColor;
  String form;
  Function(String jsonObj, dynamic data) actionSaveFunction;

  @override
  _FilterViewComponent createState() => new _FilterViewComponent();
}

class _FilterViewComponent extends State<FilterViewComponent> {
  dynamic response;

  @override
  Widget build(BuildContext context) {
    return new Scaffold(
      body: new SingleChildScrollView(
        child: new Container(
          padding: EdgeInsets.all(5),
          child: new Column(children: <Widget>[
            new JsonSchema(
              form: widget.form,
              secondaryColor: widget.secondaryColor ?? AppColors.primaryColor,
              primaryColor: widget.primaryColor ?? AppColors.primaryColor,
              onChanged: (dynamic response) {
                this.response = response;
              },
              actionSave: (data) {
                var jsonObj = {
                  for (int i = 0; i < data['fields'].length; i++)
                    if (data['fields'][i]['value'].toString() != "")
                      json.encode(data['fields'][i]['apiKeyValue'].toString()):
                          json.encode(data['fields'][i]['value'].toString())
                };
                widget.actionSaveFunction(jsonObj.toString(), data);
              },
              autovalidateMode: AutovalidateMode.always,
              buttonSave: true,
              buttonCancel: true,
              buttonText: "Apply",
              actionCancel: () {
                Navigator.of(context).pop();
              },
            ),
          ]),
        ),
      ),
    );
  }
}
