/*
    Refer License for Terms & Conditions
 */

import 'package:bui_component/Constants/AppColors.dart';
import 'package:flutter/material.dart';

// ignore: must_be_immutable
class HomeScreenComponent extends StatefulWidget {
  final Function() onMenuPressed;
  final Function() onFilterClicked;
  final Function(int s) onPopUpMenuFunction;
  final Color backgroundColor;
  final bool showFilterView;
  final List<PopupMenuItem> popUpMenu;
  final Widget child;

  HomeScreenComponent({
    Key key,
    this.onMenuPressed,
    this.onPopUpMenuFunction,
    this.onFilterClicked,
    this.backgroundColor,
    this.child,
    this.popUpMenu,
    this.showFilterView,
  });

  @override
  _HomeScreenComponentState createState() => _HomeScreenComponentState();
}

class _HomeScreenComponentState extends State<HomeScreenComponent> {
  bool isGridView = false;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: AppColors.APP_COLOR_WHITE,
      body: SafeArea(
          child: Stack(
        children: [
          Container(
            height: 60,
            color: widget.backgroundColor != null
                ? widget.backgroundColor
                : AppColors.APP_COLOR_PRIMARY,
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: <Widget>[
                ClipRRect(
                  borderRadius: BorderRadius.all(Radius.circular(32.0)),
                  child: InkWell(
                    splashColor: AppColors.errorWarning,
                    focusColor: AppColors.APP_COLOR_WHITE,
                    onTap: () {
                      widget.onMenuPressed();
                    },
                    child: Padding(
                      padding: const EdgeInsets.all(12.0),
                      child: Icon(
                        Icons.menu,
                        color: Colors.white,
                      ),
                    ),
                  ),
                ),
                SizedBox(
                  width: MediaQuery.of(context).size.width * 0.5,
                ),
                Visibility(
                  visible: widget.showFilterView ?? true,
                  child: InkWell(
                    onTap: () {
                      widget.onFilterClicked();
                    },
                    child: Container(
                      //padding: EdgeInsets.only(right: 2),
                      child: Icon(
                        Icons.filter_alt,
                        color: AppColors.appWhite,
                      ),
                    ),
                  ),
                ),
                Container(
                    //padding: EdgeInsets.only(right: 2),
                    child: PopupMenuButton(
                  elevation: 30,
                  //offset: Offset(0, 100),
                  tooltip: "More Feature",
                  itemBuilder: (context) => widget.popUpMenu,
                  onCanceled: () {},
                  onSelected: (value) {
                    widget.onPopUpMenuFunction(value);
                  },
                  icon: Icon(
                    Icons.more_vert_sharp,
                    color: AppColors.appWhite,
                  ),
                )),
              ],
            ),
          ),
          widget.child != null ? widget.child : Container(),
        ],
      )),
    );
  }
}
