import 'package:bui_component/Constants/AppColors.dart';
import 'package:bui_component/Constants/fontFamily.dart';
import 'package:bui_component/Constants/fontSize.dart';
import 'package:flutter/material.dart';

class SimpleSwitch extends StatefulWidget {
  SimpleSwitch({
    Key key,
    this.item,
    this.onChange,
    this.position,
    this.errorMessages = const {},
    this.validations = const {},
    this.decorations = const {},
    this.keyboardTypes = const {},
    this.primaryColor,
    this.secondaryColor,
  }) : super(key: key);
  final Color primaryColor;
  final Color secondaryColor;
  final dynamic item;
  final Function onChange;

  final int position;
  final Map errorMessages;
  final Map validations;
  final Map decorations;
  final Map keyboardTypes;

  @override
  _SimpleSwitch createState() => new _SimpleSwitch();
}

class _SimpleSwitch extends State<SimpleSwitch> {
  dynamic item;

  String isRequired(item, value) {
    if (value.isEmpty) {
      return widget.errorMessages[item['key']] ?? 'Please enter some text';
    }
    return null;
  }

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    item = widget.item;
    if (item['value'] == null) {
      item['value'] = false;
    }
  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return IgnorePointer(
      ignoring: item['readOnly'] != null ? item['readOnly'] : false,
      child: Visibility(
        visible: item['visibility'] != null ? item['visibility'] : true,
        child: new Container(
          margin: new EdgeInsets.only(top: 5.0),
          padding: EdgeInsets.only(bottom: 5),
          child: new Row(children: <Widget>[
            new Expanded(
              child: RichText(
                text: TextSpan(
                  text: item['label'],
                  style: new TextStyle(
                      letterSpacing: 1,
                      fontWeight: FontWeight.bold,
                      fontSize: FontSize.FONT_16,
                      color: AppColors.APP_COLOR_BLACK,
                      fontFamily: FontFamily.Gilroy),
                  children: <TextSpan>[
                    //  item['label'].toString().endsWith('*')
                    item['required'] == true
                        ? TextSpan(
                            text: ' *',
                            style: TextStyle(
                                letterSpacing: 1,
                                fontWeight: FontWeight.bold,
                                color: AppColors.errorWarning))
                        : TextSpan(
                            text: '',
                            style: TextStyle(
                                letterSpacing: 1,
                                fontWeight: FontWeight.bold,
                                fontSize: FontSize.FONT_13,
                                fontFamily: FontFamily.Gilroy,
                                color: AppColors.errorWarning)),
                  ],
                ),
              ),
            ),
            new Switch(
              value: item['value'] ?? false,
              activeColor: widget.secondaryColor,
              onChanged: (bool value) {
                this.setState(() {
                  item['value'] = value;
                  widget.onChange(widget.position, value);
                });
              },
            ),
          ]),
        ),
      ),
    );
  }
}
